/*
 * This file is part of fkmines.
 * 
 * fkmines is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * fkmines is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, Richard Molitor
 */

#ifndef GENERATE_H
#define GENERATE_H

#include <stdbool.h>

/* What the ``field'' is:
 *
 * 0 = an empty field, and open
 * 1-8 = the number, open
 * 9 = a mine
 * 10 = an empty field, closed
 * 11-18 = the number-10, closed
 * 19 = a mine, marked
 * 20 = an empty field, closed, marked
 * 21-28 = the number-20, closed, marked
 */

#define MINE (9)
#define CLOSED (10)

#define MINE_SYM '*'
#define CLOSED_SYM 'o'
#define MARK_SYM 'P'
#define ERROR_SYM '@'

bool generate (short *field, int cols, int lines, int mines);
void dump (const short *field, bool open);
int countwhites (const short *field);

#endif /* GENERATE_H */
